
; CC5X Version 3.4D, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************   2. Nov 2015  18:52  *************

	processor  12F683
	radix  DEC

	__config 0xDC

TMR0        EQU   0x01
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
OPTION_REG  EQU   0x81
ADRESH      EQU   0x1E
ADCON0      EQU   0x1F
TRISIO      EQU   0x85
OSCCON      EQU   0x8F
ANSEL       EQU   0x9F
GO          EQU   1
TRISIO0     EQU   0
TRISIO1     EQU   1
ANS0        EQU   0
ANS1        EQU   1
GP0         EQU   0
GP1         EQU   1
GP3         EQU   3
GP5         EQU   5
Status      EQU   0x21
key_raw     EQU   0x22
Zeit        EQU   0x23
OffZeit     EQU   0x25
OnZeit      EQU   0x27
LockZeit    EQU   0x29
LED_referenz EQU   0
Taste1m     EQU   1
Taste2m     EQU   2
Tmerker     EQU   3
Tester1     EQU   4
Tester2     EQU   5
OldLED      EQU   6
Lock        EQU   7
ct0         EQU   0x2C
ct1         EQU   0x2D
i           EQU   0x2E
key_state   EQU   0x2F
key_press   EQU   0x30
chstate     EQU   0x20

	GOTO main

  ; FILE D:\projekte\picsel\autosenseo-l\autosen-l.c
			;/*    AUTOSEN-L Autostart-Nachruestung fuer SENSEO-Latte HD7854     */
			;/*                       __    _                                    */                     
			;/*            __________/ /_  (_)________   ___  __  __             */       
			;/*           / ___/ ___/ __ \/ / ___/ __ \ / _ \/ / / /             */ 
			;/*          (__  ) /__/ / / / / /  / /_/ //  __/ /_/ /              */ 
			;/*         /____/\___/_/ /_/_/_/  / .___(_)___/\__,_/               */ 
			;/*                               /_/                                */ 
			;/*                                                                  */ 
			;/* (c) C.Schirp  released for non-commercial use                    */
			;/*     this header must be distributed with this source code        */ 
			;/*                                                                  */
			;/*     debounce routine by peter dannegger                          */
			;/*                                                                  */
			;/* V1.0  Erstausgabe (auf Basis autosenseo V1.3)                    */
			;/*                                                                  */
			;/*                                                                  */
			;
			;#include <D:\projekte\picsel\cc5\12F683.h>
			;//#include <C:\Eigene_Dateien\pic\cc5x\12F683.h>
			;#include <gpio.h>
			;//                  FCMEN IESO BODEN1 BODEN0 CPD CP MCLRE PWRTE WDTE FOSC2 FOSC1 FOSC0
			;//                0 0  . 0     0    0      0  .  1   1   0     1  .  1    1     0     0
			;#pragma config = 0b.0000.0000.1101.1100
			;
			;
			;
			;// Defines fuer Status
			;#define BEGIN	 1
			;#define	TPRESS1  2
			;#define	TPRESS2	 3
			;#define LED_WAIT 4
			;#define	STABIL	 5
			;#define BTNPRESSED 6
			;#define RESTART  7
			;
			;#define AN 1
			;#define AUS 0
			;
			;// Defines fuer Wartezeiten
			;#define MSWAIT    4  /* Counterstand fr 1ms */
			;#define BLINKZEIT 1172  /* ca. 1,2s */
			;#define KLICKZEIT 488   /* ca. 0,5s - 500ms */
			;#define TASTDRUCK 49    /* ca. 50ms */
			;#define MAXOFFTIME 1270 /* ca. 1,3 s */
			;#define MAXLOCKZEIT 4000 /* ca. 5 s */
			;
			;// Defines fr Tastenspannungen
			;#define TASTE2_TRESH 51  // 1,0V 84  1,65V - > 84
			;#define TASTE1_TRESH 204 // 4,0V     3,5V -> 179
			;
			;// Defines fuer Bit-Test Tastencodes
			;#define TASTE1	1
			;#define TASTE2  2
			;
			;
			;// Variablen
			;uns8 	Status;		// Zentrale Statusvariable
			;uns8    key_raw;	// Tasten-Rohwert aus ADC (sonst: GPIO)
			;uns16	Zeit;		// Universalvariable zum Zeitmessen
			;uns16   OffZeit;	// Zeit bis Off-Zustand erkannt wird (wird runtergezhlt)
			;uns16 	OnZeit;		// Zeit bis Aufgeheizt-Zustand erkannt wird (wird runtergezhlt)
			;uns16	LockZeit;	// Zeit bis Lock freigegeben wird
			;uns8	LED_referenz:1;	// Referenzmerker fr die LED-Flankenerkennung
			;uns8	Taste1m:1;	// Merker fr Taste 1
			;uns8	Taste2m:1;	// Merker fr Taste 1
			;uns8	Tmerker:1;	// Umschaltmerker T1/T2
			;uns8	Tester1:1;	// Hilfsvariable 1
			;uns8	Tester2:1;	// Hilfsvariable 1
			;uns8	OldLED:1;	// Merker fuer alten LED-Status zur Flankenerkennung
			;uns8	Lock:1;		// Autostart-Lock fr MAXLOCKZEIT
			;
			;// Variablen fr debouncing
			;uns8 ct0, ct1;
			;uns8 i;
			;uns8 key_state;
			;uns8 key_press;
			;
			;
			;// HW-Mapping
			;#define AKTIV_port GP5  /* LED am Aktiv-Port blinkt antiparallel zur Power-LED, wenn Autostart aktiv */
			;#define	LED_port GP3	/* GP3 kann nur als Eingang benutzt werden */
			;
			;void init(void)
			;{
init
			;	clrwdt();
	CLRWDT
			;
			;	OSCCON = 0b.0110.0000;	// interne clock 4MHz
	MOVLW 96
	BSF   0x03,RP0
	MOVWF OSCCON
			;
			;	OPTION = 0b.1101.0111;	// kein weak PU, TM0 in Timer-Mode, Prescaler zum Timer geschaltet
	MOVLW 215
	MOVWF OPTION_REG
			;	
			;	ANSEL  = 0b.0101.0011;  // ADCS = 101, AN0&AN1 analoge Pins
	MOVLW 83
	MOVWF ANSEL
			;
			;	AKTIV_port = AUS;	// Autostart-LED sofort aus
	BCF   0x03,RP0
	BCF   0x05,GP5
			;
			;	TRISIO = 0b.0000.1111; // 0-4 input, 5 Output
	MOVLW 15
	BSF   0x03,RP0
	MOVWF TRISIO
			;	
			;	// Entprellung zurcksetzen
			;	key_state = 0xFF;
	MOVLW 255
	BCF   0x03,RP0
	MOVWF key_state
			;	ct0 = key_state;
	MOVF  key_state,W
	MOVWF ct0
			;	ct1 = ct0;
	MOVF  ct0,W
	MOVWF ct1
			;	
			;	// Variablen
			;	Status = RESTART;
	MOVLW 7
	MOVWF Status
			;	OldLED = 0;
	BCF   0x2B,OldLED
			;	OnZeit = 0;
	CLRF  OnZeit
	CLRF  OnZeit+1
			;	LockZeit = 0;
	CLRF  LockZeit
	CLRF  LockZeit+1
			;	Lock = 0;
	BCF   0x2B,Lock
			;	OffZeit = 0;
	CLRF  OffZeit
	CLRF  OffZeit+1
			;}
	RETURN
			;
			;// Debouncing von Peter Dannegger
			;void debounce(void)
			;{
debounce
			;
			;  i = key_state ^ key_raw;	// key changed ? (active high)
	BCF   0x03,RP0
	MOVF  key_raw,W
	XORWF key_state,W
	MOVWF i
			;
			;  ct0 = ~( ct0 & i );		// reset or count ct0
	MOVF  i,W
	ANDWF ct0,W
	XORLW 255
	MOVWF ct0
			;  ct1 = ct0 ^ (ct1 & i);	// reset or count ct1
	MOVF  i,W
	ANDWF ct1,W
	XORWF ct0,W
	MOVWF ct1
			;  i &= ct0 & ct1;		// count until roll over
	MOVF  ct1,W
	ANDWF ct0,W
	ANDWF i,1
			;  key_state ^= i;		// then toggle debounced state
	MOVF  i,W
	XORWF key_state,1
			;  key_press |= key_state & i;	// 0->1: key pressing detect
	MOVF  i,W
	ANDWF key_state,W
	IORWF key_press,1
			;}
	RETURN
			;
			;// Auf Taste testen, wenn druecken erkannt Status auf chstate aendern
			;void Taste_testen(uns8 chstate)
			;{
Taste_testen
	BCF   0x03,RP0
	MOVWF chstate
			;	if (key_press & TASTE1)
	BTFSS key_press,0
	GOTO  m001
			;	{
			;		Taste1m = 1;		// merken: Taste 1 war es
	BSF   0x2B,Taste1m
			;		Status = chstate;	// Sollstatus uebernehmen
	MOVF  chstate,W
	MOVWF Status
			;		key_press ^= TASTE1;	// und den Tastendruck loeschen
	MOVLW 1
	XORWF key_press,1
			;	}
			;	else
	GOTO  m002
			;	{
			;		Taste1m = 0;
m001	BCF   0x03,RP0
	BCF   0x2B,Taste1m
			;	}
			;	
			;	if (key_press & TASTE2)
m002	BCF   0x03,RP0
	BTFSS key_press,1
	GOTO  m003
			;	{
			;		Taste2m = 1;		// merken: Taste 2 war es
	BSF   0x2B,Taste2m
			;		Status = chstate;	// Sollstatus uebernehmen
	MOVF  chstate,W
	MOVWF Status
			;		key_press ^= TASTE2;	// und den Tastendruck loeschen
	MOVLW 2
	XORWF key_press,1
			;	}
			;	else
	GOTO  m004
			;	{
			;		Taste2m = 0;
m003	BCF   0x03,RP0
	BCF   0x2B,Taste2m
			;	}	
			;}
m004	RETURN
			;
			;
			;  
			;//
			;//  Taste mit Schwellwerten analog messen und Ergebnis in key_raw eintragen
			;//
			;void tasten_messen(void)
			;{
tasten_messen
			;	key_raw = 0;		// keine Taste gedrckt	
	BCF   0x03,RP0
	CLRF  key_raw
			;		
			;	ADCON0=	 0b0000.0001;	// AD-Wandler linkssbuendig, VDD=ref,  Channel AN0, Stopped, AD_ON
	MOVLW 1
	MOVWF ADCON0
			;	GO = 1;			// Wandlung starten
	BSF   0x1F,GO
			;	
			;	while (GO);		// Auf ADC warten
m005	BCF   0x03,RP0
	BTFSS 0x1F,GO
	GOTO  m006
	GOTO  m005
			;	
			;	if (ADRESH > TASTE1_TRESH) // wir nehmen nur 8 Bit Auflsung, Vergleich mit Treshold
m006	MOVLW 205
	BCF   0x03,RP0
	SUBWF ADRESH,W
	BTFSS 0x03,Carry
	GOTO  m007
			;	{
			;		key_raw = TASTE1;	// Taste gedrckt
	MOVLW 1
	MOVWF key_raw
			;	}
			;
			;		
			;	ADCON0=	 0b0000.0101;	// AD-Wandler linkssbuendig, VDD=ref,  Channel AN1, Stopped, AD_ON
m007	MOVLW 5
	BCF   0x03,RP0
	MOVWF ADCON0
			;	GO = 1;			// Wandlung starten
	BSF   0x1F,GO
			;	
			;	while (GO);		// Auf ADC warten
m008	BCF   0x03,RP0
	BTFSS 0x1F,GO
	GOTO  m009
	GOTO  m008
			;	
			;	if (ADRESH < TASTE2_TRESH) // wir nehmen nur 8 Bit Auflsung, Vergleich mit Treshold
m009	MOVLW 51
	BCF   0x03,RP0
	SUBWF ADRESH,W
	BTFSC 0x03,Carry
	GOTO  m010
			;	{
			;		key_raw += TASTE2;	// Taste gedrckt
	MOVLW 2
	ADDWF key_raw,1
			;	}
			;		
			;}
m010	RETURN
			;
			;
			;
			;// Zeitmessung resetten
			;void Uhr_starten(void)
			;{
Uhr_starten
			;	TMR0=0;
	BCF   0x03,RP0
	CLRF  TMR0
			;	Zeit=0;
	CLRF  Zeit
	CLRF  Zeit+1
			;}
	RETURN
			;
			;// rund 0,001024s warten (1MHz clock / 256 Vorteiler / Zhlerstand 4)
			;void wait1ms(void)
			;{
wait1ms
			;	TMR0 = 0;
	BCF   0x03,RP0
	CLRF  TMR0
			;	while (TMR0 < MSWAIT);
m011	MOVLW 4
	BCF   0x03,RP0
	SUBWF TMR0,W
	BTFSC 0x03,Carry
	GOTO  m012
	GOTO  m011
			;		
			;}
m012	RETURN
			;
			;
			;// Test auf "Off-Zustand"
			;void OffTest(void)
			;{
OffTest
			;
			;	if (LED_port)
	BCF   0x03,RP0
	BTFSS 0x05,GP3
	GOTO  m013
			;	{
			;		// LED an, dann Uhr aufziehen
			;		OffZeit	= MAXOFFTIME;
	MOVLW 246
	MOVWF OffZeit
	MOVLW 4
	MOVWF OffZeit+1
			;			
			;	}
			;	else if (OffZeit > 0)
	GOTO  m015
m013	BCF   0x03,RP0
	MOVF  OffZeit,W
	IORWF OffZeit+1,W
	BTFSC 0x03,Zero_
	GOTO  m014
			;	{
			;		// LED ist zwar aus, aber Zeit noch nicht abgelaufen
			;		OffZeit--;
	DECF  OffZeit,1
	INCF  OffZeit,W
	BTFSC 0x03,Zero_
	DECF  OffZeit+1,1
			;	}
			;	else
	GOTO  m015
			;	{
			;		Status = RESTART; // Off-Zustand erkannt: immer im RESET-Status hngenbleiben
m014	MOVLW 7
	BCF   0x03,RP0
	MOVWF Status
			;	}
			;	
			;}
m015	RETURN
			;
			;// Test auf Lock-Zustand
			;// Wenn die LED lnger als MAXOFFTIME eingeschaltet ist, wird Lock gesetzt und LockZeit auf Maxlockzeit aufgezogen
			;// erst wenn die LED mal wieder aus ist, wird der OnZeit-Timer mal wieder gestartet & Lockzeit nicht mehr auf Max gesetzt,
			;// so dass der Lockzeit-Timer abluft und das Lock wieder freigegeben wird.
			;void LockTest(void)
			;{
LockTest
			;
			;	if (LED_port)
	BCF   0x03,RP0
	BTFSS 0x05,GP3
	GOTO  m019
			;	{
			;		// wenn vorher aus war, Zeitmessung starten
			;		if (!OldLED)
	BTFSC 0x2B,OldLED
	GOTO  m016
			;		{
			;			OnZeit = MAXOFFTIME;
	MOVLW 246
	MOVWF OnZeit
	MOVLW 4
	MOVWF OnZeit+1
			;		}
			;		else if (OnZeit > 0)
	GOTO  m018
m016	BCF   0x03,RP0
	MOVF  OnZeit,W
	IORWF OnZeit+1,W
	BTFSC 0x03,Zero_
	GOTO  m017
			;		{
			;			// 
			;			OnZeit--;
	DECF  OnZeit,1
	INCF  OnZeit,W
	BTFSC 0x03,Zero_
	DECF  OnZeit+1,1
			;		}
			;		else // LED ist laenger als 1,3 s an -> Autostart sperren
	GOTO  m018
			;		{
			;			Lock = 1;
m017	BCF   0x03,RP0
	BSF   0x2B,Lock
			;			LockZeit = MAXLOCKZEIT;
	MOVLW 160
	MOVWF LockZeit
	MOVLW 15
	MOVWF LockZeit+1
			;		}
			;			
			;	}
			;	else // LED ist  aus
m018	GOTO  m019
			;	{
			;		// egal
			;	}
			;	
			;	if (LockZeit > 0)
m019	BCF   0x03,RP0
	MOVF  LockZeit,W
	IORWF LockZeit+1,W
	BTFSC 0x03,Zero_
	GOTO  m020
			;	{
			;		// 
			;		LockZeit--;
	DECF  LockZeit,1
	INCF  LockZeit,W
	BTFSC 0x03,Zero_
	DECF  LockZeit+1,1
			;	}
			;	else // Lockzeit ist abgelaufen, Lock freigeben
	GOTO  m021
			;	{
			;		Lock = 0;
m020	BCF   0x03,RP0
	BCF   0x2B,Lock
			;	}
			;	
			;	// alten Zustand merken
			;	OldLED = LED_port;
m021	BCF   0x03,RP0
	BCF   0x2B,OldLED
	BTFSC 0x05,GP3
	BSF   0x2B,OldLED
			;	
			;}
	RETURN
			;
			;
			;// Tastenemulation betaetigen 
			;
			;void Taste_an(void)
			;{
Taste_an
			;	// Je nach Taste 1/2 Puls setzen	
			;	if (Tmerker)
	BCF   0x03,RP0
	BTFSS 0x2B,Tmerker
	GOTO  m022
			;	{		
			;		GP1 = 0;// Low anlegen ist fuer T2 aktiv
	BCF   0x05,GP1
			;		ANS1 = 0; // Port auf Digital umschalten
	BSF   0x03,RP0
	BCF   0x9F,ANS1
			;		TRISIO1 = 0;// Port auf Ausgang schalten		
	BCF   0x85,TRISIO1
			;	}
			;	else
	GOTO  m023
			;	{		
			;		GP0 = 1;  // High anlegen ist fuer T1 aktiv
m022	BCF   0x03,RP0
	BSF   0x05,GP0
			;		ANS0 = 0; // Port auf Digital umschalten
	BSF   0x03,RP0
	BCF   0x9F,ANS0
			;		TRISIO0 = 0;// Port auf Ausgang schalten		
	BCF   0x85,TRISIO0
			;	}
			;}
m023	RETURN
			;
			;// Tastenemulation wieder auf nicht bettigt
			;
			;void Taste_aus(void)
			;{
Taste_aus
			;	TRISIO = 0b.0000.1111; // Ports auf Input schalten: 0-4 input, 5 Output	
	MOVLW 15
	BSF   0x03,RP0
	MOVWF TRISIO
			;	ANSEL  = 0b.0101.0011;  // Ports auf analog schalten ADCS = 101, AN0&AN1 analoge Pins
	MOVLW 83
	MOVWF ANSEL
			;}
	RETURN
			;
			;
			;void main (void)
			;{
main
			;	
			;	init();
	CALL  init
			;	
			;	while (1)
			;	{
			;		clrwdt();
m024	CLRWDT
			;		// i/O einlesen
			;		tasten_messen();
	CALL  tasten_messen
			;		debounce();
	CALL  debounce
			;		// 1ms-Takt
			;		wait1ms();
	CALL  wait1ms
			;		// Uhr weiterzhlen
			;		Zeit++;	
	BCF   0x03,RP0
	INCF  Zeit,1
	BTFSC 0x03,Zero_
	INCF  Zeit+1,1
			;		// Aus-Zustand immer abprfen
			;		OffTest();
	CALL  OffTest
			;		// Lockzustand prfen
			;		LockTest();
	CALL  LockTest
			;		
			;		if (Status == BEGIN)
	BCF   0x03,RP0
	DECF  Status,W
	BTFSS 0x03,Zero_
	GOTO  m028
			;		{
			;			// Tastendruck testen, wenn nicht gelockt
			;			if (!Lock)
	BTFSC 0x2B,Lock
	GOTO  m025
			;			{
			;				Taste_testen(TPRESS1);
	MOVLW 2
	CALL  Taste_testen
			;			}
			;			
			;			// wenn Tastendruck T1 erkannt, Uhr starten, Taste merken
			;			if (Taste1m)
m025	BCF   0x03,RP0
	BTFSS 0x2B,Taste1m
	GOTO  m026
			;			{
			;				Uhr_starten();
	CALL  Uhr_starten
			;				Tmerker = 0;
	BCF   0x03,RP0
	BCF   0x2B,Tmerker
			;			}
			;			
			;			// wenn Tastendruck T2 erkannt, Uhr starten, Taste merken
			;			else if (Taste2m)
	GOTO  m027
m026	BCF   0x03,RP0
	BTFSS 0x2B,Taste2m
	GOTO  m027
			;			{
			;				Uhr_starten();
	CALL  Uhr_starten
			;				Tmerker = 1;
	BCF   0x03,RP0
	BSF   0x2B,Tmerker
			;			}
			;		}
			;		// Zustand nach Taste 1x gedrckt
			;		else if (Status == TPRESS1)
m027	GOTO  m032
m028	BCF   0x03,RP0
	MOVF  Status,W
	XORLW 2
	BTFSS 0x03,Zero_
	GOTO  m032
			;		{
			;			// Tastendruck testen 
			;			Taste_testen(TPRESS1);
	MOVLW 2
	CALL  Taste_testen
			;			
			;			// Bitvariablen ausrechnen (Compilerbeschraenkung, geht nicht im if() )
			;			Tester1 = !Tmerker;
	BCF   0x03,RP0
	BSF   0x2B,Tester1
	BTFSC 0x2B,Tmerker
	BCF   0x2B,Tester1
			;			Tester1 &= Taste1m;
	BTFSS 0x2B,Taste1m
	BCF   0x2B,Tester1
			;			Tester2 = Taste2m;
	BCF   0x2B,Tester2
	BTFSC 0x2B,Taste2m
	BSF   0x2B,Tester2
			;			Tester2 &= Tmerker;
	BTFSS 0x2B,Tmerker
	BCF   0x2B,Tester2
			;			
			;			// wenn gleicher Tastendruck erkannt, nchster State
			;			if (Tester1)
	BTFSS 0x2B,Tester1
	GOTO  m029
			;			{
			;				Status = TPRESS2;
	MOVLW 3
	MOVWF Status
			;			}
			;			else if (Tester2)
	GOTO  m032
m029	BCF   0x03,RP0
	BTFSS 0x2B,Tester2
	GOTO  m030
			;			{
			;				Status = TPRESS2;
	MOVLW 3
	MOVWF Status
			;			}
			;			
			;			// wenn die Doppelklickzeit abgelaufen ist, wieder alles auf Anfang
			;			else if (Zeit > KLICKZEIT)
	GOTO  m032
m030	MOVLW 1
	BCF   0x03,RP0
	SUBWF Zeit+1,W
	BTFSS 0x03,Carry
	GOTO  m032
	BTFSS 0x03,Zero_
	GOTO  m031
	MOVLW 233
	SUBWF Zeit,W
	BTFSS 0x03,Carry
	GOTO  m032
			;			{
			;				Status = RESTART;
m031	MOVLW 7
	BCF   0x03,RP0
	MOVWF Status
			;			}
			;
			;		}
			;		// Zustand nach Taste 2x gedrckt,  LED-Signal samplen
			;		if (Status == TPRESS2)
m032	BCF   0x03,RP0
	MOVF  Status,W
	XORLW 3
	BTFSS 0x03,Zero_
	GOTO  m033
			;		{		
			;			LED_referenz=LED_port;
	BCF   0x2B,LED_referenz
	BTFSC 0x05,GP3
	BSF   0x2B,LED_referenz
			;			Uhr_starten();
	CALL  Uhr_starten
			;			Status = LED_WAIT;
	MOVLW 4
	BCF   0x03,RP0
	MOVWF Status
			;			// nach Doppelclick nochmal Extrazeit wegen Bug in der HD7810/69/A
			;			OffZeit	= MAXOFFTIME;
	MOVLW 246
	MOVWF OffZeit
	MOVLW 4
	MOVWF OffZeit+1
			;		}
			;
			;		//warten auf stabiles LED-Signal		
			;		if (Status == LED_WAIT)
m033	BCF   0x03,RP0
	MOVF  Status,W
	XORLW 4
	BTFSS 0x03,Zero_
	GOTO  m040
			;		{
			;			// erneuter Tastendruck bricht ab
			;			Taste_testen(RESTART);
	MOVLW 7
	CALL  Taste_testen
			;			
			;			// Aktiv-LED blinken lassen
			;			if (LED_port)
	BCF   0x03,RP0
	BTFSS 0x05,GP3
	GOTO  m034
			;			{
			;				AKTIV_port = AUS;
	BCF   0x05,GP5
			;			}
			;			else
	GOTO  m035
			;			{
			;				AKTIV_port = AN;
m034	BCF   0x03,RP0
	BSF   0x05,GP5
			;			}
			;			
			;			// wenn sich der LED-Zustand gendert hat, neu starten
			;			if (LED_referenz != LED_port)
m035	BCF   0x03,RP0
	BTFSC 0x2B,LED_referenz
	GOTO  m036
	BTFSC 0x05,GP3
	GOTO  m037
	GOTO  m038
m036	BCF   0x03,RP0
	BTFSC 0x05,GP3
	GOTO  m038
			;			{
			;				LED_referenz=LED_port;
m037	BCF   0x03,RP0
	BCF   0x2B,LED_referenz
	BTFSC 0x05,GP3
	BSF   0x2B,LED_referenz
			;				Uhr_starten();
	CALL  Uhr_starten
			;			}	
			;			
			;			// Zeit abgelaufen, lnger als 1,2s stabil, unsere LED aus
			;			if (Zeit > BLINKZEIT)
m038	MOVLW 4
	BCF   0x03,RP0
	SUBWF Zeit+1,W
	BTFSS 0x03,Carry
	GOTO  m040
	BTFSS 0x03,Zero_
	GOTO  m039
	MOVLW 149
	SUBWF Zeit,W
	BTFSS 0x03,Carry
	GOTO  m040
			;			{
			;				Status = STABIL;
m039	MOVLW 5
	BCF   0x03,RP0
	MOVWF Status
			;				AKTIV_port = AUS;
	BCF   0x05,GP5
			;			}
			;			
			;		}
			;		// wir haben einen stabilen LED-Zustand!
			;		if (Status == STABIL)
m040	BCF   0x03,RP0
	MOVF  Status,W
	XORLW 5
	BTFSS 0x03,Zero_
	GOTO  m042
			;		{
			;			// Wenn LED an ist, Knopf drcken!
			;			if (LED_port == AN)
	BTFSS 0x05,GP3
	GOTO  m041
			;			{
			;				Taste_an();
	CALL  Taste_an
			;				
			;				Uhr_starten();
	CALL  Uhr_starten
			;				
			;				Status = BTNPRESSED;
	MOVLW 6
	BCF   0x03,RP0
	MOVWF Status
			;			}
			;			else
	GOTO  m042
			;			{
			;				Status = RESTART;
m041	MOVLW 7
	BCF   0x03,RP0
	MOVWF Status
			;			}
			;		}
			;		
			;		if (Status == BTNPRESSED)
m042	BCF   0x03,RP0
	MOVF  Status,W
	XORLW 6
	BTFSS 0x03,Zero_
	GOTO  m044
			;		{
			;			// wenn Taste lang genug gedrckt -> alles auf Anfang
			;			if (Zeit > TASTDRUCK)
	MOVF  Zeit+1,W
	BTFSS 0x03,Zero_
	GOTO  m043
	MOVLW 50
	SUBWF Zeit,W
	BTFSS 0x03,Carry
	GOTO  m044
			;			{
			;				Taste_aus();
m043	CALL  Taste_aus
			;				
			;				Status = RESTART;	
	MOVLW 7
	BCF   0x03,RP0
	MOVWF Status
			;			}
			;		}
			;		
			;		// alles auf Anfang setzen
			;		if (Status == RESTART)
m044	BCF   0x03,RP0
	MOVF  Status,W
	XORLW 7
	BTFSS 0x03,Zero_
	GOTO  m045
			;		{
			;			Taste1m = 0; /* beide Tastenmerker zuruecksetzen */
	BCF   0x2B,Taste1m
			;			Taste2m = 0;
	BCF   0x2B,Taste2m
			;			Status = BEGIN;
	MOVLW 1
	MOVWF Status
			;			AKTIV_port = AUS;
	BCF   0x05,GP5
			;		}
			;	}; // von while(1)
m045	GOTO  m024

	END


; *** KEY INFO ***

; 0x0001   31 word(s)  1 % : init
; 0x0020   21 word(s)  1 % : debounce
; 0x0035   24 word(s)  1 % : Taste_testen
; 0x004D   32 word(s)  1 % : tasten_messen
; 0x006D    5 word(s)  0 % : Uhr_starten
; 0x0072    9 word(s)  0 % : wait1ms
; 0x007B   22 word(s)  1 % : OffTest
; 0x0091   44 word(s)  2 % : LockTest
; 0x00BD   14 word(s)  0 % : Taste_an
; 0x00CB    6 word(s)  0 % : Taste_aus
; 0x00D1  178 word(s)  8 % : main

; RAM usage: 17 bytes (1 local), 111 bytes free
; Maximum call level: 1
; Total of 387 code words (18 %)
